<?php

/**
 * @file
 * Processing Flmngr file manager requests.
 */

require __DIR__ . '/lib/autoload.php';

use EdSDK\FlmngrServer\FlmngrServer;

use Drupal\Core\DrupalKernel;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Exception\HttpExceptionInterface;

$autoloader = require_once 'autoload.php';

try {
  $request = Request::createFromGlobals();
  $kernel = DrupalKernel::createFromRequest($request, $autoloader, 'prod');
}
catch (HttpExceptionInterface $e) {
  $response = new Response('', $e->getStatusCode());
  $response->prepare($request)->send();
  exit;
}

$user = Drupal::currentUser();

if ($user->hasPermission("edit any article content")) {
  FlmngrServer::flmngrRequest(
    [
      'dirFiles' => realpath(".") . '/sites/default/files/flmngr',
      'dirTmp' => realpath(".") . '/sites/default/files/flmngr-tmp',
      'dirCache' => realpath(".") . '/sites/default/files/flmngr-cache',
    ]
  );
}
else {
  $response = new Response('', 403);
  $response->prepare($request)->send();
  exit;
}
