<?php

namespace EdSDK\FileUploaderServer\lib;

use EdSDK\FileUploaderServer\lib\action\ActionError;
use EdSDK\FileUploaderServer\lib\action\ActionUploadAddFile;
use EdSDK\FileUploaderServer\lib\action\ActionUploadCancel;
use EdSDK\FileUploaderServer\lib\action\ActionUploadCommit;
use EdSDK\FileUploaderServer\lib\action\ActionUploadInit;
use EdSDK\FileUploaderServer\lib\action\ActionUploadRemoveFile;

/**
 * Actions list.
 */
class Actions {

  protected $actions = [];

  /**
   * Creates the list.
   */
  public function __construct() {
    $this->actions[] = new ActionError();

    $this->actions[] = new ActionUploadInit();
    $this->actions[] = new ActionUploadAddFile();
    $this->actions[] = new ActionUploadRemoveFile();
    $this->actions[] = new ActionUploadCommit();
    $this->actions[] = new ActionUploadCancel();
  }

  /**
   * Gets action for error.
   */
  public function getActionError() {
    return $this->getAction("error");
  }

  /**
   * Gets action by name.
   */
  public function getAction($name) {
    for ($i = 0; $i < count($this->actions); $i++) {
      if ($this->actions[$i]->getName() === $name) {
        return $this->actions[$i];
      }
    }
    return NULL;
  }

}
